
#include <iostream>

#define CATCH 1

#include "dyn"

#define debug(var) do{ \
    std::cout << #var << " = " << (var).getvalue() << ": "; \
    (var).debug(); \
    std::cout << std::endl; }while(0)

int main(void)
{
#if CATCH
    try {
#endif
    dyn<int> a,b,c;
    
#if DYNDEBUG > 0
    std::cout << "&a = \33[31m" << AddrName(&a) << "\33[37m\n"
                 "&b = \33[31m" << AddrName(&b) << "\33[37m\n"
                 "&c = \33[31m" << AddrName(&c) << "\33[37m\n";
#endif

    a = 1;
    b = 2;
    c = 3;
    
    debug(a);
    debug(b);
    debug(c);

#if 0
    c = (a+b)*(a+b);
    
    debug(a);
    debug(b);
    debug(c);
#endif

#if 0    
    std::cout << "Muutetaan a 9:ksi\n";
    
    a = 9;
    debug(a);    
    debug(b);
    debug(c);
    
    std::cout << "Listn b kahdesti\n";
    
    for(int i=0; i<2; ++i)
        c += b;
        
    debug(c);
#endif    

#if 0
    std::cout << "Suoritetaan: c *= c\n";
    c *= c;
    debug(c);
    
    std::cout << "Self-assignment (c=c)\n";
    c=c;
    debug(c);
#endif

#if 0
    std::cout << "Kerrotaan viidell\n";
    c *= 5;
    debug(c);
    
    std::cout << "Muutetaan b kolmeksi\n";
    b = 3;
    debug(b);
    debug(c);
    
    std::cout << "Suoritetaan: c=3\n";

    c=3;
    debug(a);
    debug(b);
    debug(c);
#endif

#if 0
    std::cout << "Suoritetaan: c = (a + b*3 + 7 * (b / c))\n";
    c = (a + b*3 + 7 * (b / c));
#endif

#if 1
    std::cout << "Suoritetaan: b = a+b/c\n";
    b = a+b/c;
    
    debug(a);
    debug(b);
    debug(c);
#endif

	c=3;

#if CATCH
    } catch(dynerror tmp)
    {
        std::cerr << "DYN: " << tmp << std::endl;
    }
#endif

    return 0;
}

